#ifndef __SCENEENTITYCONVERTER_H
#define __SCENEENTITYCONVERTER_H

#include "common.h"
#include "AxisAlignedBox3.h"


namespace CHCDemoEngine 
{

class Material;
class Transform3;
class Camera;
class SceneEntity;
class Plane3;


/** Class that converts geometric objects to scene entities
*/
class SceneEntityConverter
{
public:
	/** Creates a scene entity.
	*/
	SceneEntityConverter() {};
	/** Converts a box to a scene entity
	*/
	SceneEntity *ConvertBox(const AxisAlignedBox3 &box, Material *mat, Transform3 *trafo);	
	/** Converts a sphere to a scene entity
	*/
	SceneEntity *ConvertSphere(float radius, float xspans, float yspans, Material *mat, Transform3 *trafo);	
	/** Converts a plane to a scene entity
	*/
	SceneEntity *ConvertPlane(const Plane3 &plane, 
		                      float xsize, 
							  float ysize,
							  float xspans, 
							  float yspans,
							  Material *mat, 
							  Transform3 *trafo);
};

}

#endif // __SCENEENTITYCONVERTER_H